ICU 76.1: icu::StringEnumeration Class Reference

ICU 76.1 76.1

Public Member Functions | Protected Member Functions | Protected Attributes
icu::StringEnumeration Class Referenceabstract

Base class for 'pure' C++ implementations of uenum api. More...

`#include <strenum.h>`

Inheritance diagram for icu::StringEnumeration:

## Public Member Functions
virtual | ~StringEnumeration ()
| Destructor. More...
virtual StringEnumeration * | clone () const
| Clone this object, an instance of a subclass of StringEnumeration. More...
virtual int32_t | count (UErrorCode &status) const =0
virtual const char * | next (int32_t *resultLength, UErrorCode &status)
virtual const char16_t * | unext (int32_t *resultLength, UErrorCode &status)
virtual const UnicodeString * | snext (UErrorCode &status)
virtual void | reset (UErrorCode &status)=0
virtual bool | operator== (const StringEnumeration &that) const
| Compares this enumeration to other to check if both are equal. More...
virtual bool | operator!= (const StringEnumeration &that) const
| Compares this enumeration to other to check if both are not equal. More...
Public Member Functions inherited from icu::UObject
virtual | ~UObject ()
| Destructor. More...
virtual UClassID | getDynamicClassID () const
| ICU4C "poor man's RTTI", returns a UClassID for the actual ICU class. More...

## Protected Member Functions
| StringEnumeration ()
| Default constructor for use with default implementations and subclasses. More...
void | ensureCharsCapacity (int32_t capacity, UErrorCode &status)
| Ensures that chars is at least as large as the requested capacity. More...
UnicodeString * | setChars (const char *s, int32_t length, UErrorCode &status)
| Converts s to Unicode and sets unistr to the result. More...

## Protected Attributes
UnicodeString | unistr
| UnicodeString field for use with default implementations and subclasses. More...
char | charsBuffer [32]
| char * default buffer for use with default implementations and subclasses. More...
char * | chars
| char * buffer for use with default implementations and subclasses. More...
int32_t | charsCapacity
| Capacity of chars, for use with default implementations and subclasses. More...

## Detailed Description

Base class for 'pure' C++ implementations of uenum api.

Adds a method that returns the next UnicodeString since in C++ this can be a common storage format for strings.

The model is that the enumeration is over strings maintained by a 'service.' At any point, the service might change, invalidating the enumerator (though this is expected to be rare). The iterator returns an error if this has occurred. Lack of the error is no guarantee that the service didn't change immediately after the call, so the returned string still might not be 'valid' on subsequent use.

Strings may take the form of const char*, const char16_t*, or const UnicodeString*. The type you get is determine by the variant of 'next' that you call. In general the StringEnumeration is optimized for one of these types, but all StringEnumerations can return all types. Returned strings are each terminated with a NUL. Depending on the service data, they might also include embedded NUL characters, so API is provided to optionally return the true length, counting the embedded NULs but not counting the terminating NUL.

The pointers returned by next, unext, and snext become invalid upon any subsequent call to the enumeration's destructor, next, unext, snext, or reset.

ICU 2.8 adds some default implementations and helper functions for subclasses.

Stable:
  ICU 2.4

Definition at line 61 of file strenum.h.

## Constructor & Destructor Documentation

## ◆ ~StringEnumeration()

virtual icu::StringEnumeration::~StringEnumeration | ( |  | ) |
| virtual

Destructor.

Stable:
  ICU 2.4

## ◆ StringEnumeration()

icu::StringEnumeration::StringEnumeration | ( |  | ) |
| protected

Default constructor for use with default implementations and subclasses.

Stable:
  ICU 2.8

## Member Function Documentation

## ◆ clone()

virtual StringEnumeration* icu::StringEnumeration::clone | ( |  | ) | const
| virtual

Clone this object, an instance of a subclass of StringEnumeration.

Clones can be used concurrently in multiple threads. If a subclass does not implement clone(), or if an error occurs, then nullptr is returned. The caller must delete the clone.

Returns
  a clone of this object

See also
  getDynamicClassID

Stable:
  ICU 2.8

## ◆ count()

virtual int32_t icu::StringEnumeration::count | ( | UErrorCode & | status | ) | const
| pure virtual

Return the number of elements that the iterator traverses. If the iterator is out of sync with its service, status is set to U_ENUM_OUT_OF_SYNC_ERROR, and the return value is zero.

The return value will not change except possibly as a result of a subsequent call to reset, or if the iterator becomes out of sync.

This is a convenience function. It can end up being very expensive as all the items might have to be pre-fetched (depending on the storage format of the data being traversed).

Parameters

  status | the error code.

Returns
  number of elements in the iterator.

Stable:
  ICU 2.4

## ◆ ensureCharsCapacity()

void icu::StringEnumeration::ensureCharsCapacity | ( | int32_t | capacity,
|  | UErrorCode & | status
| ) |  |
| protected

Ensures that chars is at least as large as the requested capacity.

For use with default implementations and subclasses.

Parameters

  capacity | Requested capacity.
  status | ICU in/out error code.

Stable:
  ICU 2.8

## ◆ next()

virtual const char* icu::StringEnumeration::next | ( | int32_t * | resultLength,
|  | UErrorCode & | status
| ) |  |
| virtual

Returns the next element as a NUL-terminated char*. If there are no more elements, returns nullptr. If the resultLength pointer is not nullptr, the length of the string (not counting the terminating NUL) is returned at that address. If an error status is returned, the value at resultLength is undefined.

The returned pointer is owned by this iterator and must not be deleted by the caller. The pointer is valid until the next call to next, unext, snext, reset, or the enumerator's destructor.

If the iterator is out of sync with its service, status is set to U_ENUM_OUT_OF_SYNC_ERROR and nullptr is returned.

If the native service string is a char16_t* string, it is converted to char* with the invariant converter. If the conversion fails (because a character cannot be converted) then status is set to U_INVARIANT_CONVERSION_ERROR and the return value is undefined (though not nullptr).

Starting with ICU 2.8, the default implementation calls snext() and handles the conversion. Either next() or snext() must be implemented differently by a subclass.

Parameters

  status | the error code.
  resultLength | a pointer to receive the length, can be nullptr.

Returns
  a pointer to the string, or nullptr.

Stable:
  ICU 2.4

## ◆ operator!=()

virtual bool icu::StringEnumeration::operator!= | ( | const StringEnumeration & | that | ) | const
| virtual

Compares this enumeration to other to check if both are not equal.

Parameters

  that | The other string enumeration to compare this object to

Returns
  true if the enumerations are equal. false if not.

Stable:
  ICU 3.6

## ◆ operator==()

virtual bool icu::StringEnumeration::operator== | ( | const StringEnumeration & | that | ) | const
| virtual

Compares this enumeration to other to check if both are equal.

Parameters

  that | The other string enumeration to compare this object to

Returns
  true if the enumerations are equal. false if not.

Stable:
  ICU 3.6

## ◆ reset()

virtual void icu::StringEnumeration::reset | ( | UErrorCode & | status | ) |
| pure virtual

Resets the iterator. This re-establishes sync with the service and rewinds the iterator to start at the first element.

Previous pointers returned by next, unext, or snext become invalid, and the value returned by count might change.

Parameters

  status | the error code.

Stable:
  ICU 2.4

## ◆ setChars()

UnicodeString* icu::StringEnumeration::setChars | ( | const char * | s,
|  | int32_t | length,
|  | UErrorCode & | status
| ) |  |
| protected

Converts s to Unicode and sets unistr to the result.

For use with default implementations and subclasses, especially for implementations of snext() in terms of next(). This is provided with a helper function instead of a default implementation of snext() to avoid potential infinite loops between next() and snext().

For example:

const UnicodeString* snext(UErrorCode& status) {
int32_t resultLength=0;
const char *s=next(&resultLength, status);
return setChars(s, resultLength, status);
}
icu::StringEnumeration::setChars
UnicodeString * setChars(const char *s, int32_t length, UErrorCode &status)
Converts s to Unicode and sets unistr to the result.
icu::StringEnumeration::next
virtual const char * next(int32_t *resultLength, UErrorCode &status)
icu::StringEnumeration::snext
virtual const UnicodeString * snext(UErrorCode &status)
UErrorCode
UErrorCode
Standard ICU4C error code type, a substitute for exceptions.
Definition: utypes.h:430

Parameters

  s | String to be converted to Unicode.
  length | Length of the string.
  status | ICU in/out error code.

Returns
  A pointer to unistr.

Stable:
  ICU 2.8

## ◆ snext()

virtual const UnicodeString* icu::StringEnumeration::snext | ( | UErrorCode & | status | ) |
| virtual

Returns the next element a UnicodeString*. If there are no more elements, returns nullptr.

The returned pointer is owned by this iterator and must not be deleted by the caller. The pointer is valid until the next call to next, unext, snext, reset, or the enumerator's destructor.

If the iterator is out of sync with its service, status is set to U_ENUM_OUT_OF_SYNC_ERROR and nullptr is returned.

Starting with ICU 2.8, the default implementation calls next() and handles the conversion. Either next() or snext() must be implemented differently by a subclass.

Parameters

  status | the error code.

Returns
  a pointer to the string, or nullptr.

Stable:
  ICU 2.4

## ◆ unext()

virtual const char16_t* icu::StringEnumeration::unext | ( | int32_t * | resultLength,
|  | UErrorCode & | status
| ) |  |
| virtual

Returns the next element as a NUL-terminated char16_t*. If there are no more elements, returns nullptr. If the resultLength pointer is not nullptr, the length of the string (not counting the terminating NUL) is returned at that address. If an error status is returned, the value at resultLength is undefined.

The returned pointer is owned by this iterator and must not be deleted by the caller. The pointer is valid until the next call to next, unext, snext, reset, or the enumerator's destructor.

If the iterator is out of sync with its service, status is set to U_ENUM_OUT_OF_SYNC_ERROR and nullptr is returned.

Starting with ICU 2.8, the default implementation calls snext() and handles the conversion.

Parameters

  status | the error code.
  resultLength | a pointer to receive the length, can be nullptr.

Returns
  a pointer to the string, or nullptr.

Stable:
  ICU 2.4

## Field Documentation

## ◆ chars

char* icu::StringEnumeration::chars
| protected

char * buffer for use with default implementations and subclasses.

Allocated in constructor and in ensureCharsCapacity().

Stable:
  ICU 2.8

Definition at line 228 of file strenum.h.

## ◆ charsBuffer

char icu::StringEnumeration::charsBuffer[32]
| protected

char * default buffer for use with default implementations and subclasses.

Stable:
  ICU 2.8

Definition at line 222 of file strenum.h.

## ◆ charsCapacity

int32_t icu::StringEnumeration::charsCapacity
| protected

Capacity of chars, for use with default implementations and subclasses.

Stable:
  ICU 2.8

Definition at line 233 of file strenum.h.

## ◆ unistr

UnicodeString icu::StringEnumeration::unistr
| protected

UnicodeString field for use with default implementations and subclasses.

Stable:
  ICU 2.8

Definition at line 217 of file strenum.h.

The documentation for this class was generated from the following file:

- common/unicode/strenum.h